(defpackage :cl-rabbit
  (:use :cl)
  (:documentation "CFFI-based interface to RabbitMQ")
  (:export #:basic-ack
           #:basic-consume
           #:basic-nack
           #:basic-publish
           #:channel-close
           #:channel-flow
           #:channel-open
           #:consume-message
           #:destroy-connection
           #:envelope
           #:envelope/channel
           #:envelope/consumer-tag
           #:envelope/delivery-tag
           #:envelope/exchange
           #:envelope/message
           #:envelope/routing-key
           #:exchange-bind
           #:exchange-declare
           #:exchange-delete
           #:exchange-unbind
           #:login-sasl-plain
           #:message
           #:message/body
           #:message/properties
           #:new-connection
           #:queue-bind
           #:queue-declare
           #:queue-unbind
           #:rabbitmq-error
           #:rabbitmq-server-error
           #:socket-open
           #:tcp-socket-new
           #:with-connection
           #:version
           #:queue-purge
           #:queue-delete
           #:rabbitmq-library-error
           #:rabbitmq-library-error/error-code
           #:rabbitmq-library-error/error-description
           #:rabbitmq-server-error/type
           #:basic-cancel
           #:rabbitmq-server-error/reply-code
           #:rabbitmq-server-error/message
           #:+amqp-reply-success+
           #:+amqp-content-too-large+
           #:+amqp-no-route+
           #:+amqp-no-consumers+
           #:+amqp-access-refused+
           #:+amqp-not-found+
           #:+amqp-resource-locked+
           #:+amqp-precondition-failed+
           #:+amqp-connection-forced+
           #:+amqp-invalid-path+
           #:+amqp-frame-error+
           #:+amqp-syntax-error+
           #:+amqp-command-invalid+
           #:+amqp-channel-error+
           #:+amqp-unexpected-frame+
           #:+amqp-resource-error+
           #:+amqp-not-allowed+
           #:+amqp-not-implemented+
           #:+amqp-internal-error+
           #:tx-select
           #:tx-commit
           #:tx-rollback
           #:ssl-socket-new
           #:ssl-socket-set-cacert
           #:ssl-socket-set-verify
           #:ssl-socket-set-key-buffer
           #:set-init-ssl-library
           #:ssl-socket-set-key
           #:with-channel
           #:confirm-select
           #:simple-wait-frame
           #:method-frame-basic-acknowledgment
           #:method-frame-basic-acknowledgment/channel
           #:method-frame-basic-acknowledgment/id
           #:method-frame-basic-acknowledgment/delivery-tag
           #:method-frame-basic-acknowledgment/multiplep
           #:method-frame-basic-negative-acknowledgment
           #:method-frame-basic-negative-acknowledgment/channel
           #:method-frame-basic-negative-acknowledgment/id
           #:method-frame-basic-negative-acknowledgment/multiplep
           #:method-frame-basic-negative-acknowledgment/requeuep
           #:method-frame-basic-return
           #:method-frame-basic-return/channel
           #:method-frame-basic-return/id
           #:method-frame-basic-return/reply-code
           #:method-frame-basic-return/reply-text
           #:method-frame-basic-return/exchange
           #:method-frame-basic-return/routing-key
           #:method-frame-basic-deliver
           #:method-frame-basic-deliver/channel
           #:method-frame-basic-deliver/id
           #:method-frame-basic-deliver/consumer-tag
           #:method-frame-basic-deliver/delivery-tag
           #:method-frame-basic-deliver/redeliveredp
           #:method-frame-basic-deliver/exchange
           #:method-frame-basic-deliver/routing-key
           #:content-header-frame
           #:content-header-frame/channel
           #:content-header-frame/class-id
           #:content-header-frame/body-size
           #:content-header-frame/properties
           #:content-body-frame
           #:content-body-frame/channel
           #:content-body-frame/body
           #:method-frame-error
           #:method-frame-error/channel
           #:method-frame-error/method-id))

(defpackage :cl-rabbit.examples
  (:use :cl :cl-rabbit)
  (:documentation "Examples for cl-rabbit"))
